'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _factories = require('../factories');

var _factories2 = _interopRequireDefault(_factories);

var _actions = require('../actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var initialState = {
  now: [],
  next: []
};

var reducer = function reducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  switch (action.type) {
    case _actions.FLASH_NEXT:
      {
        var message = action.message,
            messageType = action.messageType;

        return _extends({}, state, {
          next: [].concat(_toConsumableArray(state.next), [new _factories2.default(message, messageType)])
        });
      }

    case _actions.FLASH_NOW:
      {
        var _message = action.message,
            _messageType = action.messageType;

        return _extends({}, state, {
          now: [].concat(_toConsumableArray(state.now), [new _factories2.default(_message, _messageType)])
        });
      }

    case _actions.CLEAR_FLASH:
      {
        var key = action.key;

        return _extends({}, state, {
          now: state.now.filter(function (d) {
            return d.key !== key;
          })
        });
      }

    case _actions.CYCLE_FLASH:
      {
        return _extends({}, state, {
          now: state.next,
          next: initialState.next
        });
      }

    default:
      return state;
  }
};

exports.default = reducer;